Unit EBCDIC;

(*
Copyright (C) 1998-99 Paul Toth <tothpaul@multimania.com>
 http://www.multimania.com/tothpaul

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*)



Interface

Uses
 SysUtils;

Procedure AnsiToEbcdicA(var s:string);
Procedure EbcdicToAnsiA(var s:string);

function AnsiToEbcdicW(s:string):string;
function EbcdicToAnsiW(s:string):string;

Procedure AnsiToEbcdic(var s; size:integer);
Procedure EbcdicToAnsi(var s; size:integer);

Procedure EbcdicToInt(var data;Size:integer);
Function  EbcdicUnpack(var data;PackSize,Size:integer):string;
Procedure Ebcdicpack(Value:string; var data;PackSize:integer);

{ ANSI to EBCDIC translation }
Const
 A2E:array[#0..#255] of char=(
  #$00,#$01,#$02,#$03,#$37,#$2D,#$2E,#$2F,#$16,#$05,#$25,#$0B,#$0C,#$0D,#$0E,#$0F,
  #$10,#$11,#$12,#$13,#$3C,#$3D,#$32,#$26,#$18,#$19,#$3F,#$27,#$1C,#$1D,#$1E,#$1F,
  #$40,#$4F,#$7F,#$B1,#$5B,#$6C,#$50,#$7D,#$4D,#$5D,#$5C,#$4E,#$6B,#$60,#$4B,#$61,
  #$F0,#$F1,#$F2,#$F3,#$F4,#$F5,#$F6,#$F7,#$F8,#$F9,#$7A,#$5E,#$4C,#$7E,#$6E,#$6F,
  #$44,#$C1,#$C2,#$C3,#$C4,#$C5,#$C6,#$C7,#$C8,#$C9,#$D1,#$D2,#$D3,#$D4,#$D5,#$D6,
  #$D7,#$D8,#$D9,#$E2,#$E3,#$E4,#$E5,#$E6,#$E7,#$E8,#$E9,#$90,#$48,#$B5,#$5F,#$6D,
  #$A0,#$81,#$82,#$83,#$84,#$85,#$86,#$87,#$88,#$89,#$91,#$92,#$93,#$94,#$95,#$96,
  #$97,#$98,#$99,#$A2,#$A3,#$A4,#$A5,#$A6,#$A7,#$A8,#$A9,#$51,#$BB,#$54,#$BD,#$07,
  #$20,#$21,#$22,#$23,#$24,#$15,#$06,#$17,#$28,#$29,#$2A,#$2B,#$2C,#$09,#$0A,#$1B,
  #$30,#$31,#$1A,#$33,#$34,#$35,#$36,#$08,#$38,#$39,#$3A,#$3B,#$04,#$14,#$3E,#$FF,
  #$41,#$AA,#$B0,#$7B,#$9F,#$B2,#$DD,#$5A,#$A1,#$B4,#$9A,#$8A,#$BA,#$CA,#$AF,#$BC,
  #$4A,#$8F,#$EA,#$FA,#$BE,#$79,#$B6,#$B3,#$9D,#$DA,#$9B,#$8B,#$B7,#$B8,#$B9,#$AB,
  #$64,#$65,#$62,#$66,#$63,#$67,#$9E,#$68,#$74,#$71,#$72,#$73,#$78,#$75,#$76,#$77,
  #$AC,#$69,#$ED,#$EE,#$EB,#$EF,#$EC,#$BF,#$80,#$FD,#$FE,#$FB,#$FC,#$AD,#$AE,#$59,
  #$7C,#$45,#$42,#$46,#$43,#$47,#$9C,#$E0,#$D0,#$C0,#$52,#$53,#$58,#$55,#$56,#$57,
  #$8C,#$49,#$CD,#$CE,#$CB,#$CF,#$CC,#$E1,#$70,#$6A,#$DE,#$DB,#$DC,#$8D,#$8E,#$DF
 );

{ EBCDIC to ANSI translation }
Const
 E2A:array[#0..#255] of char=(
  #$00,#$01,#$02,#$03,#$9C,#$09,#$86,#$7F,#$97,#$8D,#$8E,#$0B,#$0C,#$0D,#$0E,#$0F,
  #$10,#$11,#$12,#$13,#$9D,#$85,#$08,#$87,#$18,#$19,#$92,#$8F,#$1C,#$1D,#$1E,#$1F,
  #$80,#$81,#$82,#$83,#$84,#$0A,#$17,#$1B,#$88,#$89,#$8A,#$8B,#$8C,#$05,#$06,#$07,
  #$90,#$91,#$16,#$93,#$94,#$95,#$96,#$04,#$98,#$99,#$9A,#$9B,#$14,#$15,#$9E,#$1A,
  #$20,#$A0,#$E2,#$E4,#$40,#$E1,#$E3,#$E5,#$5C,#$F1,#$B0,#$2E,#$3C,#$28,#$2B,#$21,
  #$26,#$7B,#$EA,#$EB,#$7D,#$ED,#$EE,#$EF,#$EC,#$DF,#$A7,#$24,#$2A,#$29,#$3B,#$5E,
  #$2D,#$2F,#$C2,#$C4,#$C0,#$C1,#$C3,#$C5,#$C7,#$D1,#$F9,#$2C,#$25,#$5F,#$3E,#$3F,
  #$F8,#$C9,#$CA,#$CB,#$C8,#$CD,#$CE,#$CF,#$CC,#$B5,#$3A,#$A3,#$E0,#$27,#$3D,#$22,
  #$D8,#$61,#$62,#$63,#$64,#$65,#$66,#$67,#$68,#$69,#$AB,#$BB,#$F0,#$FD,#$FE,#$B1,
  #$5B,#$6A,#$6B,#$6C,#$6D,#$6E,#$6F,#$70,#$71,#$72,#$AA,#$BA,#$E6,#$B8,#$C6,#$A4,
  #$60,#$A8,#$73,#$74,#$75,#$76,#$77,#$78,#$79,#$7A,#$A1,#$BF,#$D0,#$DD,#$DE,#$AE,
  #$A2,#$23,#$A5,#$B7,#$A9,#$5D,#$B6,#$BC,#$BD,#$BE,#$AC,#$7C,#$AF,#$7E,#$B4,#$D7,
  #$E9,#$41,#$42,#$43,#$44,#$45,#$46,#$47,#$48,#$49,#$AD,#$F4,#$F6,#$F2,#$F3,#$F5,
  #$E8,#$4A,#$4B,#$4C,#$4D,#$4E,#$4F,#$50,#$51,#$52,#$B9,#$FB,#$FC,#$A6,#$FA,#$FF,
  #$E7,#$F7,#$53,#$54,#$55,#$56,#$57,#$58,#$59,#$5A,#$B2,#$D4,#$D6,#$D2,#$D3,#$D5,
  #$30,#$31,#$32,#$33,#$34,#$35,#$36,#$37,#$38,#$39,#$B3,#$DB,#$DC,#$D9,#$DA,#$9F
 );

Implementation

Type
 PByte=^AByte;
 AByte=Array[byte] of byte;

Procedure AnsiToEbcdicA(var s:string);
 var
  i:integer;
 begin
  for i:=1 to length(s) do s[i]:=A2E[s[i]];
 end;

Procedure EbcdicToAnsiA(var s:string);
 var
  i:integer;
 begin
  for i:=1 to length(s) do s[i]:=E2A[s[i]];
 end;

Function AnsiToEbcdicW(s:string):string;
 var
  i:integer;
 begin
  result:=s;
  for i:=1 to length(s) do result[i]:=A2E[s[i]];
 end;

Function EbcdicToAnsiW(s:string):string;
 var
  i:integer;
 begin
  result:=s;
  for i:=1 to length(s) do result[i]:=E2A[s[i]];
 end;

Procedure AnsiToEbcdic(var s; size:integer);
 var
  i:integer;
  p:pchar;
 begin
  p:=@s;
  for i:=1 to Size do begin p^:=A2E[p^]; inc(p); end;
 end;

Procedure EbcdicToAnsi(var s; size:integer);
 var
  i:integer;
  p:pchar;
 begin
  p:=@s;
  for i:=1 to Size do begin p^:=E2A[p^]; inc(p); end;
 end;

Procedure EbcdicToInt;
 var
  i:integer;
  databyte:PByte;
 begin
  databyte:=@data;
  for i:=0 to size-1 do databyte^[i]:=databyte^[i] div 15 - 1;
 end;

Function EbcdicUnpack;
 Var
  i,j:integer; b:byte;
  databyte:PByte;
  high:boolean;
  zero:string;
 begin
  databyte:=@data;
  Result:=''; zero:='';
  j:=PackSize-1;
  high:=true;
  while Size>0 do begin
   dec(size);
   b:=databyte^[j];
   if high then begin b:=b shr 4; dec(j); end else b:=b and $F;
   high:=not high;
   if b=0 then
    zero:=zero+'0'
   else begin
    inc(b,ord('0'));
    if length(zero)>0 then begin
     Result:=Zero+Result;
     Zero:='';
    end;
    Result:=chr(b)+Result;
   end;
  end;
 end;

Procedure EbcdicPack;
 var
  i,j:integer; v,b:byte;
  databyte:PByte;
  high:boolean;
  size:integer;
 begin
  databyte:=@data;
  FillChar(databyte^,PackSize,0);
  v:=$F;
  j:=PackSize-1;
  high:=true;
  size:=length(value);
  while Size>0 do begin
   b:=ord(Value[Size])-ord('0'); dec(size);
   if high then begin
    databyte^[j]:=(b shl 4) or v;
    v:=0;
    dec(j);
   end else
    v:=b;
   high:=not high;
  end;
  if v>0 then databyte^[j]:=v;
 end;

end.
